const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const payouts = sequelize.define(
    'payouts',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

beneficiary_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"merchant",


"courier"

        ],

      },

amount: {
        type: DataTypes.DECIMAL,
      
      

      },

currency: {
        type: DataTypes.TEXT,
      
      

      },

payout_method: {
        type: DataTypes.ENUM,
      
      

        values: [

"bank_transfer",


"mobile_money",


"cash"

        ],

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"processing",


"paid",


"failed",


"cancelled"

        ],

      },

payout_reference: {
        type: DataTypes.TEXT,
      
      

      },

requested_at: {
        type: DataTypes.DATE,
      
      

      },

paid_at: {
        type: DataTypes.DATE,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  payouts.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



























//end loop



    db.payouts.belongsTo(db.users, {
      as: 'beneficiary_user',
      foreignKey: {
        name: 'beneficiary_userId',
      },
      constraints: false,
    });

    db.payouts.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.payouts.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.payouts.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return payouts;
};


